unit DemoBCR;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    //OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    BCRSession:Integer;
    procedure RecognizeBarcodesAndShowResults(DIBHandle:Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Uses RecoBCRAPI,Clipbrd;

procedure TForm1.RecognizeBarcodesAndShowResults(DIBHandle:Integer);
 Var BarCodes:Integer;
     Buffer:PAnsiChar;
     BarType:Integer;
     BarOrientation:Integer;
     i:integer;
begin
 // Recognize the barcode
 // Type: Code39, I2of5
 // Max expected codes: 4
 // Codes length: from 3 to 20 characters
 // Virtual laser step/size: 2/10
 // Image Quality: normal
 // Orientation: LeftToRight or RightToLeft
 // CheckDigit Verification: enabled
 BarCodes:=BCR_RecognizeEx(BCRSession,DIBHandle,BCR_Code39 or BCR_2of5Interlaved,4,3,20,2,10,BCR_NORMAL_QUALITY,BCR_LeftToRight or BCR_RightToLeft,BCR_CHECKDIGIT_ENABLED);
 // Show the number of recognized barcodes
 //ShowMessage('Barcodes recognized: '+IntToStr(BarCodes));
 // Retrieve info for each barcode recognized
 for i:=0 to BarCodes-1 do
  begin
   // Create the buffer for the result
   GetMem(Buffer,255);
   // Retrieve the recognized text
   BCR_GetCodeText(BCRSession,i,Buffer);
   // Retrieve the code type
   BarType:=BCR_GetCodeType(BCRSession,i);
   // Retrieve the code orientation
   BarOrientation:=BCR_GetCodeOrientation(BCRSession,i);
   // Show the code index, data and orientation
   ShowMessage('Barcode '+IntToStr(i+1)+' of '+IntToStr(BarCodes)+' text is '+Buffer+' - Type: '+IntToStr(BarType)+' - Orientation: '+IntTOSTr(BarOrientation));
   // Free the buffer
   FreeMem(Buffer);
  end;
 end;

procedure TForm1.Button1Click(Sender: TObject);
 Var DIBHandle:Integer;
begin
 // Check if an image is in clipboard
 if Clipboard.HasFormat(CF_DIB) then
  begin
   // Open the clipboard
   Clipboard.Open;
   // Retrieve the dib
   DIBHandle:=Clipboard.GetAsHandle(CF_DIB);
   // Perform the recognition
   RecognizeBarcodesAndShowResults(DIBHandle);
   // Close the clipboard
   Clipboard.Close;
  end else ShowMessage('No image available in clipboard !');
end;


procedure TForm1.Button2Click(Sender: TObject);
Var DIBHandle:Integer;
begin
 // Allows user to select an image file to recognize
 if OpenDialog1.Execute then
  begin
   DIBHandle:=BCR_LoadImage(BCRSession,PAnsiChar(AnsiString(OpenDialog1.FileName)));
   if DIBHandle<>0 then
    begin
     // Perform the recognition
     RecognizeBarcodesAndShowResults(DIBHandle);
     // Free image from memory
     BCR_FreeImage(BCRSession,DIBHandle);
    end else ShowMessage('Unable to load image !');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 // Open the BCR session
 BCRSession:=BCR_Init('demo','demo');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 // Close the BCR session
 BCR_Done(BCRSession);
end;

end.

